program factory;

type
   TPrimFactory = class
   end;
   TBaseFactory = class (TPrimFactory)
      class function add (A, B: TBaseFactory) : TBaseFactory; virtual;
   end;
   TDeriFactory = class (TBaseFactory)
      class function add (A, B: TBaseFactory) : TDeriFactory; override;
   end;
   
   class function TBaseFactory.add (A, B: TBaseFactory) : TBaseFactory;
   begin
      WriteLn ('TBaseFactory.add');
      add := TBaseFactory.Create;
   end;
   
   class function TDeriFactory.add (A, B: TBaseFactory) : TDeriFactory;
   begin
      WriteLn ('TDeriFactory.add');
      add := TDeriFactory.Create;
   end;
   
var
   MyFactory : class of TBaseFactory;

begin
   MyFactory := TDeriFactory;
   MyFactory.add (MyFactory.Create, MyFactory.Create);
end.   
