program fields_ref_counting;
uses SysUtils, Classes;

type
   TRecord = record
      RI: IInterface
   end;
   TClass = class
      RI: IInterface
   end;

var
  IO: TInterfacedObject;
  R: TRecord;
  DynR: ^TRecord;
  C: TClass;
begin
  { no memory leak.
    We use interfaces, and our _AddRef / _Release
    do ref counting. }
  IO := TInterfacedObject.Create;
  R.RI := IO;
  new (DynR);
  DynR^.RI := TInterfacedObject.Create;
  dispose (DynR);
  C := TClass.Create;
  C.RI := TInterfacedObject.Create;
  C.Free;
end.
