program for_in_iterobj;
uses SysUtils;
type
   TRangeEnumerator = class
   private
      FCurrent, Last: Integer;
   public
      constructor Create(aFirst, aLast: Integer); 
      function MoveNext: Boolean;
      property Current: Integer read FCurrent;
   end;
 
   TRange = class
   private
      First, Last: Integer;
   public
      constructor Create(aFirst, aLast: Integer);
      function GetEnumerator: TRangeEnumerator;
   end;
 
constructor TRangeEnumerator.Create(aFirst, aLast: Integer);
begin
   inherited Create;
   FCurrent := aFirst - 1;
   Last := aLast;
end;
 
function TRangeEnumerator.MoveNext: Boolean;
begin
   Inc (FCurrent);
   Result := FCurrent <= Last;
end;

constructor TRange.Create(aFirst, aLast: Integer);
begin
   inherited Create;
   First := aFirst;
   Last := aLast;
end;
 
function TRange.GetEnumerator: TRangeEnumerator;
begin
   Result := TRangeEnumerator.Create(First, Last);
end;

var
   Container: TRange;
   Pos: Integer;
begin
   Container := TRange.Create (3, 7);
   for Pos in Container do Write (Pos, ', ');
   WriteLn('Next try:');
   for Pos in Container do Write (Pos, ', ');
   WriteLn;
   Container.Free;
end.