program interfaces_ref_counting;
uses Classes;

var
  C: TComponent;
  IO: TInterfacedObject;
  I: IInterface;
begin
  { memory leak, no interface usage
    (no _AddRef / _Release call): }
  C := TComponent.Create(nil);

  { memory leak, although we use interface,
    but TComponent's _AddRef / _Release
    don't really do anything }
  C := TComponent.Create(nil);
  I := C;
  { same as above }
  I := TComponent.Create(nil);

  { memory leak, no interface usage
    (no _AddRef / _Release call): }
  IO := TInterfacedObject.Create;

  { no memory leak.
    We use interfaces, and our _AddRef / _Release
    do ref counting. }
  IO := TInterfacedObject.Create;
  I := IO;
  { same as above }
  I := TInterfacedObject.Create;
end.
