program multi_intf;
uses SysUtils, Classes;
{$interfaces CORBA}
type
   IBase = interface
      function ShowBase: String;
   end;
   IA = interface (IBase)
      function Show: String;
   end;
   IB = interface (IBase)
      function Show: String;
   end;
   
   TMulti = class (IA, IB)
      function Show: String;
      function ShowBase: String;
      function ShowA: String;
      function ShowB: String;
      function IA.Show = ShowA;
      function IB.ShowBase = ShowB;
   end;
   function TMulti.Show: String;
   begin
      Show := 'TMulti.Show';
   end;
   function TMulti.ShowBase: String;
   begin
      ShowBase := 'TMulti.ShowBase';
   end;
   function TMulti.ShowA: String;
   begin
      ShowA := 'TMulti.ShowA';
   end;
   function TMulti.ShowB: String;
   begin
      ShowB := 'TMulti.ShowB';
   end;
var
   Multi: TMulti;
   Base: IBase;
   A: IA;
   B: IB;
begin
   Multi := TMulti.Create;
   //Base := Multi;
   A := Multi;
   B := Multi;
   WriteLn ('A.ShowBase=', A.ShowBase, '; B.ShowBase=', B.ShowBase);
   WriteLn ('A.Show=', A.Show, '; B.Show=', B.Show);
   Multi.Free;
end.