program no_counting;
uses SysUtils, Classes;
type
   IBasic = interface
      function Show: String;
   end;
   
   TNoCount = class (IBasic)
      function Show: String;
      function QueryInterface(constref IID:TGUID; out Obj)
         :LongInt; CDecl;
      function _AddRef:LongInt; CDecl;
      function _Release:LongInt; CDecl;
   end;
   function TNoCount.Show: String;
   begin
      Show := 'TNoCount.Show';
   end;
   function TNoCount.QueryInterface
      (constref IID:TGUID; out Obj):LongInt; CDecl;
   begin
      if GetInterface(IID, Obj) then Result := 0
   end;
   function TNoCount._AddRef:LongInt; CDecl;
   begin
      Result := -1
   end;
   function TNoCount._Release:LongInt; CDecl;
   begin
      Result := -1
   end;
var
   Basic: IBasic;
   NoCount: TNoCount;
begin
   NoCount := TNoCount.Create;
   Basic := NoCount;
   WriteLn ('Basic.Show=', Basic.Show,
            '; NoCount.Show=', NoCount.Show);
   Basic := nil;
   NoCount.Destroy;
end.
